(*
 * Copyright 2005 Toshiyuki Maeda
 *
 * This file is part of TALK.
 *
 * TALK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * TALK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *)

open Types

open Big_int

type dbg_info = string list

type address =
{
	ad_base		: integer;
(*
	ad_scale	: nativeint;
*)
(*
	ad_scale	: big_int;
	ad_index	: integer;
*)
(*
	ad_offset	: nativeint;
*)
	ad_offset	: big_int;
}

type annotation_inst =
	| A_ROLL of integer * named_type
	| A_UNROLL of integer
	| A_PACK of integer * pack_type * constructor list
	| A_UNPACK of dbg_info * integer
	| A_SPLIT of dbg_info * integer * integer
	| A_CONCAT of dbg_info * integer * integer
	| A_TUPLE_SPLIT of dbg_info * integer * integer
	| A_TUPLE_CONCAT of integer * integer

	(* These are auxiliary instructions that can be represented with above instructions. *)
	| A_CAST_TO_TUPLE of dbg_info * integer
	| A_CAST_TO_ARRAY of dbg_info * integer
	| A_CAST_TO_STACK of dbg_info * integer

type annotation_attr =
	| A_ADDRESS	of address
	| A_FALL

	| A_NEWNAMES	of dbg_info list

	| A_SIGNED

type annotation =
	| A_INST of annotation_inst
	| A_ATTR of annotation_attr

type all_annots =
{
        annot_insts	: annotation_inst list;
        annot_attrs	: annotation_attr list;
}
