(*
 * Copyright 2005 Toshiyuki Maeda
 *
 * This file is part of TALK.
 *
 * TALK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * TALK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *)

open Types
open Types_op
open Format
open Output_types

let verify filename =
	try
		let named_types, blks, cblks, annots = Read_elf.read_elf_from_file filename in

		Typing.type_check named_types blks cblks annots;
		printf "Type checked.\n"
	with Typing_error.Type_error (message) ->
		printf "Type error! %s\n" message

let specs = []

let main () =
	try
		Arg.parse specs (fun filename -> verify filename) "usage : verifier filename"
	with Failure msg ->
		print_endline msg


let _ =
	if !Sys.interactive then
		()
	else
		main ()
